; =============================================================================================
; tabs	: 8 spaces (See Lesson_1 for beginning)
; ---------------------------------------------------------------------------------------------
	.586			; from .386 32 bits code is the same upto Pentium (.486, .586P)
	.model	flat, stdcall	; (tiny, small,...) (c, syscall,...)
	option	casemap:none	; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
	include \masm32\include\kernel32.inc	; operating system kernel functions
	include \masm32\include\windows.inc	; common definitions (const, functions...)
	include \masm32\include\user32.inc	; various user interface & other functions
	include \masm32\include\gdi32.inc	; graphics related functions

	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib	; where .obj code is located or import library
; =============================================================================================
; Local macros
; ============
	m2m	macro	m1, m2			; memory to memory (source -> destination)
		push	m2
		pop	m1
	endm

	return	macro	arg
		mov	eax, arg
		ret
	endm
; =============================================================================================
; Local prototypes
; ================
	WinMain 	proto

; Main Window
	ShowMainWindow	proto
	RegisterWindow	proto lpfnWndProc:dword, lpszClassName:dword
	CreateWindow	proto lpszClassName:dword, lpszWindowName:dword
	WndProc 	proto hWnd:dword, nMsg:dword, wParam:dword, lParam:dword

; Helpers
	ShowInfo	proto lpszText:dword
	ShowMessage	proto lpszText:dword, lpszCaption:dword
; =============================================================================================
.data
; Common
	hThisInstance	dd 0			; this instance (module handle)
; Main Window
	szClassName	db "AppName", 0
	szMainTitle	db "Main Caption", 0,
; Messages
	szMsgCaption	db "App Name", 0
; =============================================================================================
.code
start:
	invoke	WinMain
	invoke	ExitProcess, 0	; program returns ...
	ret			; 1 byte ending
; =============================================================================================
; Local Procedures
; ================
WinMain 	proc		; where working code is located
	invoke	ShowMainWindow
	ret
WinMain 	endp
; =============================================================================================
; Main Window
; --------------
ShowMainWindow	proc
	invoke	RegisterWindow, addr WndProc, addr szClassName
	invoke	CreateWindow, addr szClassName, addr szMainTitle
	ret
ShowMainWindow	endp
; ---------------------------------------------------------------------------------------------
RegisterWindow	proc lpfnWndProc:dword, lpszClassName:dword
; locals
	local	wc : WNDCLASSEX
; code
	;==================================================
	; Fill WNDCLASSEX structure with required variables
	;==================================================
	mov	wc.cbSize,		sizeof WNDCLASSEX
	mov	wc.style,		CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	m2m	wc.lpfnWndProc, 	lpfnWndProc
	m2m	wc.hInstance,		hThisInstance		; << NOTE: macro not mnemonic

;	invoke	GetStockObject, 	BLACK_BRUSH
;	mov	wc.hbrBackground,	eax			; or: COLOR_WINDOW + 1
	mov	wc.hbrBackground,	COLOR_WINDOW + 1	; index + 1

	mov	wc.lpszMenuName,	NULL
	m2m	wc.lpszClassName,	lpszClassName

	invoke	LoadIcon,		NULL, IDI_APPLICATION	; hThisInstance, icon ID
	mov	wc.hIcon,		eax
	mov	wc.hIconSm,		0

	invoke	LoadCursor,		NULL, IDC_ARROW 	; System Cursor
	mov	wc.hCursor,		eax

	mov	wc.cbClsExtra,		0
	mov	wc.cbWndExtra,		0

	invoke	RegisterClassEx,	addr wc
	ret
RegisterWindow	endp
; ---------------------------------------------------------------------------------------------
CreateWindow	proc lpszClassName:dword, lpszWindowName:dword
	ret
CreateWindow	endp
; ---------------------------------------------------------------------------------------------
; Main Window Procedure(s)
; ------------------------
WndProc 	proc hWnd:dword, nMsg:dword, wParam:dword, lParam:dword
	ret
WndProc 	endp
; =============================================================================================
; Helpers
; ==============
ShowInfo	proc lpszText:dword

	invoke	ShowMessage, lpszText, addr szMsgCaption
	ret
ShowInfo	endp
; ---------------------------------------------------------------------------------------------
ShowMessage	proc lpszText:dword, lpszCaption:dword

	invoke	MessageBox, NULL, lpszText, lpszCaption, MB_OK
	ret
ShowMessage	endp
; =============================================================================================
; Start point
end	start
