; =============================================================================================
; tabs  : 8 spaces
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; ---------------------------------------------------------------------------------------------
; ++
        includelib \masm32\lib\msvcrt.lib       ; standard c library
; ---------------------------------------------------------------------------------------------
; Our libraries and dll-s
        include AsmDll.inc                      ; prototypes - see in
        includelib AsmDll.lib                   ; import library (for AsmDll.dll)
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm
; =============================================================================================
; Local prototypes
; ================
        WinMain         proto

; Helpers
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword
; ++
        IntToString     proto value:dword, buffer:dword, base:dword
        ShowInteger     proto value:dword, base:dword

        ShowBinInt      proto value:dword
        ShowDecInt      proto value:dword
        ShowHexInt      proto value:dword
; ---------------------------------------------------------------------------------------------
; Standard C functions
; --------------------
        _itoa           proto c value:dword, buffer:dword, base:dword
; =============================================================================================
.data
; Messages
        szMsgCaption    db "App Name", 0
        szIsFinished    db "Application is finished", 0
; Common
        szCmnBuffer     db 128 dup(?)
; =============================================================================================
.code
start:
        invoke  WinMain
        invoke  ShowInfo, addr szIsFinished
        invoke  ExitProcess, 0  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc            ; where working code is located

        invoke  SumInt, 2, 3    ; 5
        invoke  ShowDecInt, eax

        invoke  SubInt, 5, 3    ; 2
        invoke  ShowDecInt, eax
        ret
WinMain         endp
; =============================================================================================
; Helpers
; ==============
ShowInfo        proc lpszText:dword

        invoke  ShowMessage, lpszText, addr szMsgCaption
        ret
ShowInfo        endp
; ---------------------------------------------------------------------------------------------
ShowMessage     proc lpszText, lpszCaption              ; [:dword] is defined in proto

        invoke  MessageBox, NULL, lpszText, lpszCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
; ++
IntToString     proc value:dword, buffer:dword, base:dword

        invoke  _itoa, value, buffer, base
        ret
IntToString     endp
; ---------------------------------------------------------------------------------------------
ShowInteger     proc value:dword, base:dword

        invoke  IntToString, value, addr szCmnBuffer, base
        invoke  ShowInfo, eax     ; eax - addr szCmnBuffer
        ret
ShowInteger     endp
; =============================================================================================
ShowBinInt      proc value:dword

        invoke  ShowInteger, value, 2
        ret
ShowBinInt      endp
; ---------------------------------------------------------------------------------------------
ShowDecInt      proc value:dword

        invoke  ShowInteger, value, 10
        ret
ShowDecInt      endp
; ---------------------------------------------------------------------------------------------
ShowHexInt      proc value:dword

        invoke  ShowInteger, value, 16
        ret
ShowHexInt      endp
; =============================================================================================
; Start point
end     start
