; =============================================================================================
; Struc[t], Union and Record
; =============================================================================================
; tabs  : 8 spaces (See Lesson_1 for beginning)
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; ---------------------------------------------------------------------------------------------
; ++
        include \masm32\include\masm32.inc      ; common routines (converting,...)

        includelib \masm32\lib\msvcrt.lib       ; standard c library
        includelib \masm32\lib\masm32.lib       ; common routines (converting,...)
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm

        ShowSeg macro   reg
                push    reg
                call    ShowHexInt
        endm
; =============================================================================================
; Local prototypes
; ================
        WinMain         proto

; Main Window
; Helpers
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword
; ++
        IntToString     proto value:dword, buffer:dword, base:dword
        ShowInteger     proto value:dword, base:dword

        ShowBinInt      proto value:dword
        ShowDecInt      proto value:dword
        ShowHexInt      proto value:dword
; ---------------------------------------------------------------------------------------------
; Standard C functions
; --------------------
        _itoa           proto c value:dword, buffer:dword, base:dword
; =============================================================================================
; Structures,...
; ===================
Employee struct
        FirstName       db 32 dup (0)
        LastName        db 32 dup (0)
        Salary          dd 10000
        Age             db 18
Employee ends
; =============================================================================================
; Union,...
; ===================
Pointer union                   ; occupies 6 bytes
        ShortPtr        dw 0    ; Only 16 bits
        LongPtr         dd 0    ; All 32 bits
        FarPtr          df 0    ; Offset (32 bits) and segment selector (16 bits)
Pointer ends
; =============================================================================================
; Records,...
; ===================
Date    record  Day : 5,        ; first (from msb) 5 bits
                Month : 4,      ; next (from msb) 4 bits
                Year : 16 - 9   ; last 7 bits, 0 - 127 (from 1900 - 2027)
; =============================================================================================
.data
; Messages
        szMsgCaption    db "Masm32 App", 0
        szIsFinished    db "Application is finished", 0
; Common
        szCmnBuffer     db 256 dup(?)
; Employees
        SomePerson      Employee <"Person Name", "Person Surname", 15000, 23>
        Employees       Employee 2 dup (<"First Name", "Last Name", 12000, 21>)
; Pointer (union)
        SomePtr         Pointer <1000h>
; Record
        Employeed       Date <5, 3, 2007 - 1900>
; =============================================================================================
.code
start:
        invoke  WinMain

        invoke  ShowInfo, addr szIsFinished
        invoke  ExitProcess, 0  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc

        ; Show Person (Employee)
        invoke  ShowInfo, addr SomePerson.FirstName
        invoke  ShowInfo, addr SomePerson.LastName
        invoke  ShowDecInt, SomePerson.Salary

        xor     eax, eax
        mov     al, SomePerson.Age
        invoke  ShowDecInt, eax

        ; Show Employees
        mov     ecx, length Employees   ; length Employees = 2, size Employees = 2 * size Employee
        lea     ebx, Employees          ; load effective address

@@:     ; -------------------------------
        push    ecx                     ; WinApi and c functions will not keep it (ecx)

        mov     eax, ebx
        add     eax, Employee.FirstName
        invoke  ShowInfo, eax

        mov     eax, ebx
        add     eax, Employee.LastName
        invoke  ShowInfo, eax

        invoke  ShowDecInt, [ebx + Employee.Salary]
;       invoke  ShowDecInt, (Employee ptr [ebx]).Salary

        xor     eax, eax
        mov     al, (Employee ptr [ebx]).Age
        invoke  ShowDecInt, eax

        add     ebx, size Employee
        pop     ecx
        loop    @B
        ; -------------------------------

        ; Pointer (Union)
        invoke  ShowDecInt, size SomePtr
        invoke  ShowHexInt, SomePtr.LongPtr

        ; Date (Record) - width, mask and name (Month)
        invoke  ShowDecInt, width Month ; bits
        invoke  ShowDecInt, Month       ; 'offset' from left

        ; Record Date - Change Date (Set Month)
        xor     eax, eax
        mov     al, 5
        shl     ax, Month
        and     Employeed, not mask Month
        or      Employeed, ax

        ; Record Date - Show Date (Get Month)
        xor     eax, eax
        mov     ax, Employeed
        and     ax, mask Month
        shr     ax, Month

        invoke  ShowDecInt, eax

        ret
WinMain         endp
; =============================================================================================
; Helpers
; ==============
ShowInfo        proc lpszText:dword

        invoke  ShowMessage, lpszText, addr szMsgCaption
        ret
ShowInfo        endp
; ---------------------------------------------------------------------------------------------
ShowMessage     proc lpszText:dword, lpszCaption:dword

        invoke  MessageBox, NULL, lpszText, lpszCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
; ++
IntToString     proc value:dword, buffer:dword, base:dword

        invoke  _itoa, value, buffer, base
        ret
IntToString     endp
; ---------------------------------------------------------------------------------------------
ShowInteger     proc value:dword, base:dword

        invoke  IntToString, value, addr szCmnBuffer, base
        invoke  ShowInfo, eax     ; eax - addr szCmnBuffer
        ret
ShowInteger     endp
; =============================================================================================
ShowBinInt      proc value:dword

        invoke  ShowInteger, value, 2
        ret
ShowBinInt      endp
; ---------------------------------------------------------------------------------------------
ShowDecInt      proc value:dword

        invoke  ShowInteger, value, 10
        ret
ShowDecInt      endp
; ---------------------------------------------------------------------------------------------
ShowHexInt      proc value:dword

        invoke  ShowInteger, value, 16
        ret
ShowHexInt      endp
; =============================================================================================
; Start point
end     start
; =============================================================================================
