; =============================================================================================
; String Functions: StrLen, StrChr, StrRChr, ... StrStr... (are not used here)
; Memory Functions: GlobalAlloc, GlobalFree, LocalAlloc, LocalFree
; File Functions: CreateFile, ReadFile, WriteFile, CloseHandle
; =============================================================================================
; tabs  : 8 spaces (See Lesson_1 for beginning)
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\shlwapi.inc     ; some string functions (StrChr,...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\shlwapi.lib      ; some string functions
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; ---------------------------------------------------------------------------------------------
; ++
        include \masm32\include\masm32.inc      ; common routines (converting,...)

        includelib \masm32\lib\msvcrt.lib       ; standard c library
        includelib \masm32\lib\masm32.lib       ; common routines (converting,...)
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm
; =============================================================================================
; Local prototypes
; ================
        WinMain         proto

; Main Window
; Helpers
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword
; ++
        IntToString     proto value:dword, buffer:dword, base:dword
        ShowInteger     proto value:dword, base:dword

        ShowBinInt      proto value:dword
        ShowDecInt      proto value:dword
        ShowHexInt      proto value:dword

; This program
        SetArguments    proto
        SetFileName     proto
        ProceedFile     proto
; ---------------------------------------------------------------------------------------------
; Standard C functions
; --------------------
        _itoa           proto c value:dword, buffer:dword, base:dword
; =============================================================================================
.data
; Common data
        lpszCmdLine     dd 0                    ; ! with program itself path
; Messages
        szMsgCaption    db "App Name", 0
        szIsFinished    db "Application is finished", 0
; Common
        szCmnBuffer     db 256 dup(?)
; Program's
        lpszArguments   dd 0

        lpszFileName    dd 0
        lpFileData      dd 0
        nFileSize       dd 0
        hFile           dd 0
        nBytesRead      dd 0
        nBytesWritten   dd 0
; =============================================================================================
.code
start:
        invoke  GetCommandLine
        mov     lpszCmdLine, eax

        invoke  WinMain

        invoke  ShowInfo, addr szIsFinished
        invoke  ExitProcess, 0  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc                    ; where working code is located
; 1. Command Line
        invoke  ShowInfo, lpszCmdLine
; 2. Arguments
        call    SetArguments
        cmp     byte ptr [edi], 0
        je      @F                      ; no arguments
        invoke  ShowInfo, edi
; FileName
        call    SetFileName
        invoke  ShowInfo, edi
; Proceed
        call    ProceedFile
@@:
        ret
WinMain         endp
; =============================================================================================
; This Program
SetArguments    proc
        mov     edi, lpszCmdLine
        mov     al, ' '                 ; end of path

        cmp     byte ptr [edi], '"'     ; first char
        jne     @F
        inc     edi
        mov     al, '"'
@@:
        xor     ecx, ecx
        dec     ecx
repne   scasb

; next not ' '
        mov     al, ' '
repe    scasb
        dec     edi

        mov     lpszArguments, edi
        ret     ; pointer to args in edi
SetArguments    endp
; ---------------------------------------------------------------------------------------------
SetFileName     proc
        mov     al, '"'
        cmp     [edi], al       ; first char
        jne     @F
        inc     edi
        push    edi             ; save name begin
repne   scasb
        dec     edi
        mov     byte ptr [edi], 0
        pop     edi             ; restore name begin
@@:
        mov     lpszFileName, edi
        ret
SetFileName     endp
; =============================================================================================
ProceedFile     proc
;       local   nBytesRead : dword - cannot be here - because this is in the stack (ss)
; Open
        ; CreateFile(lpFileName, dwDesiredAccess, dwShareMode, NULL, dwCreation, dwFlagsAndAttributes, NULL)
;       invoke  CreateFile, lpszArguments, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        invoke  CreateFile, edi, GENERIC_READ or GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        mov     hFile, eax
;       invoke  ShowHexInt, eax
; Is Open
        test    eax, eax
        js      FileExit
; Size
        invoke  GetFileSize, eax, NULL
        mov     nFileSize, eax
;       invoke  ShowDecInt, eax
; Alloc
        inc     eax                     ; for ending 0
;       invoke  GlobalAlloc, GPTR, eax  ; alloc and zero init
        invoke  LocalAlloc, LPTR, eax   ; alloc and zero init
        mov     lpFileData, eax
; Read
        invoke  ReadFile, hFile, eax, nFileSize, addr nBytesRead, NULL
;       invoke  ShowHexInt, eax
;       invoke  ShowInfo, lpFileData
;       invoke  ShowDecInt, nBytesRead
; Proceed
        mov     esi, lpFileData
        mov     ecx, nBytesRead
@@:
        xor     byte ptr [esi], 10101010b
        inc     esi
        loop    @B
; Begin
        invoke  SetFilePointer, hFile, 0, NULL, FILE_BEGIN
; Write
        invoke  WriteFile, hFile, lpFileData, nBytesRead, addr nBytesWritten, NULL
;       invoke  ShowHexInt, eax
;       invoke  ShowDecInt, nBytesWritten
; Length
        invoke  SetEndOfFile, hFile
; Free
;       invoke  GlobalFree, lpFileData
        invoke  LocalFree, lpFileData
        invoke  CloseHandle, hFile
FileExit:
        ret
ProceedFile     endp
; =============================================================================================
; Helpers
; ==============
ShowInfo        proc lpszText:dword

        invoke  ShowMessage, lpszText, addr szMsgCaption
        ret
ShowInfo        endp
; ---------------------------------------------------------------------------------------------
ShowMessage     proc lpszText:dword, lpszCaption:dword

        invoke  MessageBox, NULL, lpszText, lpszCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
; ++
IntToString     proc value:dword, buffer:dword, base:dword

        invoke  _itoa, value, buffer, base
        ret
IntToString     endp
; ---------------------------------------------------------------------------------------------
ShowInteger     proc value:dword, base:dword

        invoke  IntToString, value, addr szCmnBuffer, base
        invoke  ShowInfo, eax     ; eax - addr szCmnBuffer
        ret
ShowInteger     endp
; =============================================================================================
ShowBinInt      proc value:dword

        invoke  ShowInteger, value, 2
        ret
ShowBinInt      endp
; ---------------------------------------------------------------------------------------------
ShowDecInt      proc value:dword

        invoke  ShowInteger, value, 10
        ret
ShowDecInt      endp
; ---------------------------------------------------------------------------------------------
ShowHexInt      proc value:dword

        invoke  ShowInteger, value, 16
        ret
ShowHexInt      endp
; =============================================================================================
; Start point
end     start
