; ; =============================================================================================
; tabs  : 8 spaces
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
        includelib \masm32\lib\msvcrt.lib       ; _gcvt
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm
; =============================================================================================
; Local prototypes
; ================
        WinMain         proto
; Helpers
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword

        DoubleToString  proto value:qword, digits:dword
        ShowDouble      proto value:qword
        ShowValue       proto ; value from coprocessor into double and show it
        ShowStackIndex  proto ; show current index of the stack register
; ---------------------------------------------------------------------------------------------
; Standard C functions
; --------------------
        ; return char* (in eax)
        _itoa           proto c value:dword, buffer:dword, base:dword
        _gcvt           proto c value:qword, digits:dword, buffer:dword
; =============================================================================================
.data
; Common value
        szBuffer        db 256 dup (?)
        double          dq ?            ; current value in the st(0)
; Messages
        szMsgCaption    db "App Name", 0
        szIsFinished    db "Application is finished", 0
; Program's value
        ivalue          dd 2            ; integer (4 bytes) (2, 4, 8)
        value1          dd 12.345       ; float   (4 bytes)
        value2          dq 12.345e0     ; double  (8 bytes)
        value3          dt 0.12345e2    ; real    (10 bytes)
; =============================================================================================
.code
start:
        invoke  WinMain
        invoke  ShowInfo, addr szIsFinished
        invoke  ExitProcess, 0  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc            ; where working code is located
;       invoke  ShowDouble,     value1 ; problem with compiling
;       invoke  ShowDouble,     value3 ; problem with compiling
        invoke  ShowDouble,     value2

        finit                   ; initialize coprocessor
; mul                           ; fmul, fadd, fsub, fdiv, ...
        fld     value1          ; float (don't use them) -> value2 (double - 8 bytes)
        fimul   ivalue          ; i - integer
        invoke  ShowValue
; div
        fld     value2
        fld     value3          ; we cannot use tbyte as operand in memory
        fdiv
        invoke  ShowValue
; const
        fld1                    ; fldz, fld1, fldpi, fldl2e, fldl2t, fldlg2, fldln2
        invoke  ShowValue
        fldpi
        invoke  ShowValue
; cos
        fldpi
        fcos
        invoke  ShowValue

        ret
WinMain         endp
; =============================================================================================
; Helpers
; ==============
DoubleToString  proc value:qword, digits:dword

        invoke  _gcvt, value, digits, addr szBuffer
        ret
DoubleToString  endp
; ---------------------------------------------------------------------------------------------
ShowDouble      proc value:qword

        invoke  DoubleToString, value, 8
        invoke  ShowInfo, eax
        ret
ShowDouble      endp
; ---------------------------------------------------------------------------------------------
ShowValue       proc

        fst     double  ; fst <--> fstp, without p (fst) - value remains in the st(0)
;       fld     double  ; load it back to coprocessor
        invoke  ShowDouble, double
        invoke  ShowStackIndex
        ret
ShowValue       endp
; =============================================================================================
; ++
IntToString     proc value:dword, buffer:dword, base:dword

        invoke  _itoa, value, buffer, base
        ret
IntToString     endp
; ---------------------------------------------------------------------------------------------
ShowInteger     proc value:dword, base:dword

        invoke  IntToString, value, addr szBuffer, base
        invoke  ShowInfo, eax     ; eax - addr szBuffer
        ret
ShowInteger     endp
; ---------------------------------------------------------------------------------------------
ShowDecInt      proc value:dword

        invoke  ShowInteger, value, 10
        ret
ShowDecInt      endp
; =============================================================================================
ShowStackIndex  proc

        xor     eax, eax
        fstsw   ax      ; swr -> ax
        and     ax, 0011100000000000b   ; top
        shr     ax, 11
        invoke  ShowDecInt, eax
        ret
ShowStackIndex  endp
; =============================================================================================
ShowInfo        proc lpszText:dword

        invoke  ShowMessage, lpszText, addr szMsgCaption
        ret
ShowInfo        endp
; ---------------------------------------------------------------------------------------------
ShowMessage     proc lpszText, lpszCaption              ; [:dword] is defined in proto

        invoke  MessageBox, NULL, lpszText, lpszCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
; Start point
end     start